/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.definition.activity;

import org.ow2.orchestra.definition.BpelProcess;
import org.ow2.orchestra.facade.data.def.ActivityDefinitionData;
import org.ow2.orchestra.facade.data.runtime.ActivityInstanceData;
import org.ow2.orchestra.facade.runtime.ActivityType;
import org.ow2.orchestra.facade.uuid.ActivityDefinitionUUID;
import org.ow2.orchestra.pvm.activity.ExternalActivity;
import org.ow2.orchestra.runtime.BpelExecution;

/**
 * @author Guillaume Porcher
 *
 */
public interface IAbstractActivity extends ExternalActivity {

  ActivityDefinitionUUID getUuid();

  String getName();

  ActivityType getType();

  /**
   * Hook start of activity.
   *
   * @param bpelExecution
   */
  void beforeRunning(final BpelExecution bpelExecution);

  /**
   * @return a definition data
   */
  ActivityDefinitionData createDefinitionData(final BpelProcess bpelProcess);

  /**
   * @param bpelExecution the execution
   * @return an instance data
   */
  ActivityInstanceData createRuntimeData(final BpelExecution bpelExecution);

  /**
   * Hook end of activity.
   *
   * @param bpelExecution
   */
  void afterRunned(final BpelExecution bpelExecution);

  boolean isInboundMessageElement();

}