/**
 * Copyright (C) 2007  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.definition.element;

import javax.xml.namespace.QName;

/**
 * declaration of a variable in a bpel process.
 *
 * @author Charles Souillard, Tom Baeyens
 */
public class PartDefinition {

  private static final long serialVersionUID = 7921696230594148306L;

  /** xmlType attribute of this variable. */
  protected QName xmlType;

  /** element attribute of this variable. */
  protected QName element;


  protected PartDefinition() {}


  public PartDefinition(final QName xmlType, final QName element) {
    this.xmlType = xmlType;
    this.element = element;
  }


  public QName getElement() {
    return this.element;
  }

  public QName getXmlType() {
    return this.xmlType;
  }
}
