package org.ow2.orchestra.persistence;

import java.util.Collection;
import java.util.List;

import javax.xml.namespace.QName;

import org.ow2.orchestra.definition.BpelProcess;
import org.ow2.orchestra.definition.element.InboundMessageElement;
import org.ow2.orchestra.deployment.ProcessDeploymentCounter;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessInstanceUUID;
import org.ow2.orchestra.pvm.session.PvmDbSession;
import org.ow2.orchestra.runtime.BpelExecution;
import org.ow2.orchestra.runtime.WaitingExecution;
import org.ow2.orchestra.runtime.WaitingExecution.WaitingExecutionIterator;
import org.ow2.orchestra.services.OperationKey;
import org.ow2.orchestra.services.PendingMessage;

public interface RuntimeDbSession extends PvmDbSession {

  /** searches for the given BpelProcess version */
  BpelProcess findBpelProcess(String namespace, String name, int version);

  /** searches for the latest version of the given BpelProcess */
  BpelProcess findBpelProcess(String namespace, String name);


  BpelProcess findBpelProcess(ProcessDefinitionUUID processUUID, boolean lock);

  /** searches for the latest version of the given BpelProcess */
  BpelProcess getBpelProcess(ProcessDefinitionUUID pduuid);

  /** searches for all the BpelProcesses in the database */
  List<BpelProcess> getBpelProcesses();

  /** searches for all the BpelInstances in the database */
  List<BpelExecution> getBpelInstances();

  /** searches for all the BpelInstances in the database */
  BpelExecution getBpelInstance(ProcessInstanceUUID processInstanceUUID);

  /**
   * searches for all the Instances instances of the given BpelProcess in the
   * database
   */
  List<BpelExecution> getBpelInstances(QName processQName);

  /**
   * @return
   */
  ProcessDeploymentCounter getProcessDeploymentCounter();

  WaitingExecutionIterator getWaitingExecutions(InboundMessageElement inboundMessageElement);
  WaitingExecution getFirstWaitingExecution(InboundMessageElement inboundMessageElement);

  Collection<PendingMessage> getPendingMessages(OperationKey operationKey);

}
